{
VOLLSTAENDIG: Ja 
SYNTAKTISCH: NEIN
AUSGETESTET: Nein
BEMERKUNGEN: 
Bemerkungen :

  !!!  Um das Modul fuer den XSC-C-Precompiler zu verwenden, muessen  !!!
  !!!  alle Kommentare
  !!!                ($on)     nach   $on
  !!!                ($off)    nach   $off
  !!!                ($XSC-C   nach   ($XSC-C)
  !!!                XSC-C$)   nach   (XSC-C$)
  !!!  geaendert werden. Die andere Richtung gilt sinngemaess.
  !!!  Dabei stehen hierin die runden Klammern fuer die eigentlichen Kommentarklammern
  !!!  ( welche innerhalb dieses Kommentares nicht verwendet werden koennen ).
  !!!  Achtung: Keine geschachtelten Kommentare erzeugen !!!

}

MODULE mvi_ari;      {  Intervall-Matrizen und -Vektoren, Stand : 22.04.91  }


USE mv_ari, i_ari ;
 


{---------------------------------------------------------------------------}
{ 0. Vereinbarungen                                                         }
{---------------------------------------------------------------------------}



$off

GLOBAL TYPE IVECTOR  = GLOBAL DYNAMIC ARRAY [ * ] OF INTERVAL;
            IMATRIX  = GLOBAL DYNAMIC ARRAY [ * ] OF IVECTOR; 

$on


{---------------------------------------------------------------------------}
{ 1. Transferfunktionen                                                     }
{---------------------------------------------------------------------------}
{    1.0 Zuweisungen                                                        }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR := ( VAR A : IVECTOR; B : REAL );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;




GLOBAL OPERATOR := ( VAR A : IVECTOR; VAR B : INTERVAL );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  A[i]:= B
END;




GLOBAL OPERATOR := ( VAR A : IMATRIX; B : REAL );

VAR i : INTEGER;
    h : IVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;




GLOBAL OPERATOR := ( VAR A : IMATRIX; VAR B : INTERVAL );

VAR i : INTEGER;
    h : IVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO  h[i]:= B;
  FOR i:= LB(A,1) TO UB(A,1) DO  A[i]:= h
END;





GLOBAL OPERATOR := ( VAR A : IVECTOR; VAR B : RVECTOR );

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A); 
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  A[i]:= B[i+d]
END;




GLOBAL OPERATOR := ( VAR A : IMATRIX; VAR B : RMATRIX );

VAR i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
     FOR i:= al1 TO au1 DO  A[i]:= B[i+d]
END;




 
{---------------------------------------------------------------------------}
{    1.1  Transfer-Funktionen fuer Vektoren                                 }
{---------------------------------------------------------------------------}





GLOBAL FUNCTION INTVAL ( VAR A : RVECTOR ) : IVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  INTVAL[i]:= A[i]
END;




GLOBAL FUNCTION INTVAL ( VAR A, B : RVECTOR ) : IVECTOR [LB(A)..UB(A)];

VAR i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )
  ELSE
    FOR i:= al TO au DO  INTVAL[i]:= INTVAL( A[i], B[i+d] )
END;




GLOBAL FUNCTION INF ( VAR A : IVECTOR ) : RVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  INF[i]:= A[i].INF;
END;



 
GLOBAL FUNCTION SUP ( VAR A : IVECTOR ) : RVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  SUP[i]:= A[i].SUP
END;



   
{---------------------------------------------------------------------------}
{    1.2  Transfer-Funktionen fuer Matrizen                                 }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION INTVAL ( VAR A : RMATRIX ) : IMATRIX [LB(A,1)..UB(A,1),
                                                      LB(A,2)..UB(A,2)];
VAR z,s : INTEGER; 

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  INTVAL[z,s]:= A[z,s]
END;




GLOBAL FUNCTION INTVAL ( VAR A, B : RMATRIX ) : IMATRIX [LB(A,1)..UB(A,1),
                                                         LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d1:= bl1 - al1;
  d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTVAL[z,s]:= INTVAL( A[z,s], B[z+d1,s+d2] )
END;




GLOBAL FUNCTION INF ( VAR A : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                   LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  INF[z,s]:= A[z,s].INF
END;




GLOBAL FUNCTION SUP ( VAR A : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                   LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  SUP[z,s]:= A[z,s].SUP
END;




{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.1  Mittelpunkt                                                       }
{---------------------------------------------------------------------------}


 

GLOBAL FUNCTION MID( VAR A : IVECTOR ) : RVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  MID[i]:= MID( A[i] )
END;
 


 
GLOBAL FUNCTION MID( VAR A : IMATRIX ) : RMATRIX[LB(A,1)..UB(A,1),
                                                 LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;           
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MID[z,s]:= MID( A[z,s] )
END;  




{---------------------------------------------------------------------------}
{    2.2  Durchmesser                                                       }
{---------------------------------------------------------------------------}





GLOBAL FUNCTION DIAM( VAR A : IVECTOR ) : RVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIAM[i]:= DIAM( A[i] )
END;
 


 
GLOBAL FUNCTION DIAM( VAR A : IMATRIX ) : RMATRIX[LB(A,1)..UB(A,1),
                                                 LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;           
 
BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIAM[z,s]:= DIAM( A[z,s] )
END;




{---------------------------------------------------------------------------}
{    2.3  Transponierte                                                     }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION TRANSP ( VAR A : IMATRIX ) : IMATRIX [LB(A,2)..UB(A,2),
                                                      LB(A,1)..UB(A,1)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,2) TO UB(A,2) DO
  FOR s:= LB(A,1) TO UB(A,1) DO  TRANSP[z,s]:= A[s,z]
END;




{---------------------------------------------------------------------------}
{    2.4  Skalarprodukt                                                     }
{---------------------------------------------------------------------------}




{  -------->     gibt's nicht mehr    <------------  }




{---------------------------------------------------------------------------}
{    2.5  Null - Arrays                                                     }
{---------------------------------------------------------------------------}
{         2.5.1 Null - Vektoren                                             }
{---------------------------------------------------------------------------}




GLOBAL FUNCTION NULL ( VAR A : IVECTOR ) : RVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO NULL[i]:= 0.0
END;




{---------------------------------------------------------------------------}
{        2.5.2 Null - Matrizen                                              }
{---------------------------------------------------------------------------}





GLOBAL FUNCTION NULL ( VAR A : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  FOR i:= LB(A,2) TO UB(A,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;




GLOBAL FUNCTION NULL ( VAR A,B : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                      LB(B,2)..UB(B,2)];
VAR i : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];

BEGIN
  FOR i:= LB(B,2) TO UB(B,2) DO     h[i]:= 0.0;
  FOR i:= LB(A,1) TO UB(A,1) DO  NULL[i]:= h;
END;




{---------------------------------------------------------------------------}
{    2.6 Einheitsmatrizen                                                   }
{---------------------------------------------------------------------------}





GLOBAL FUNCTION ID ( VAR A : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                  LB(A,2)..UB(A,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(A,2)..UB(A,2)];

BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(A,2);  bu2:= UB(A,2);

  d:= bl2 - bl1;

  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }

  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;



GLOBAL FUNCTION ID ( VAR A,B : IMATRIX ) : RMATRIX [LB(A,1)..UB(A,1),
                                                    LB(B,2)..UB(B,2)];
VAR i,bl1,bl2,bu1,bu2,d : INTEGER;
    h : RVECTOR[LB(B,2)..UB(B,2)];

BEGIN
  bl1:= LB(A,1);  bu1:= UB(A,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

  d:= bl2 - bl1;

  FOR i:= bl2 TO bu2 DO   h[i]:= 0.0;
  FOR i:= bl1 TO bu1 DO  ID[i]:= h;   { Ganze Matrix mit 0 fuellen. }

  IF ( bu2-bl2 ) < ( bu1-bl1 ) THEN  FOR i:= bl2 TO bu2 DO  ID[i-d,i]:= 1.0
                               ELSE  FOR i:= bl1 TO bu1 DO  ID[i,i+d]:= 1.0;
END;





{---------------------------------------------------------------------------}
{ 3. Vergleiche                                                             }
{---------------------------------------------------------------------------}
{    3.1  Vergleiche von Argumenten RVECTOR mit RVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR V33                                                                 }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul MV_ARI definiert.                       }




{---------------------------------------------------------------------------}
{    3.2  Vergleiche von Argumenten RVECTOR mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR V34                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : RVECTOR; VAR B : IVECTOR ) INVRVIR : BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
      i := al;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN    i:= SUCC(i)
                        ELSE drin:= FALSE;
   INVRVIR:= drin
  END
END;




GLOBAL OPERATOR = ( VAR A : RVECTOR; VAR B : IVECTOR ) EQVRVIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVRVIR:= gleich;
  END;
END;




GLOBAL OPERATOR <> ( VAR A : RVECTOR; VAR B : IVECTOR ) NEVRVIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVRVIR:= ungleich;
  END;  
END;




{---------------------------------------------------------------------------}
{    3.3  Vergleiche von Argumenten IVECTOR mit RVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR V43                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR = ( VAR B : IVECTOR; VAR A : RVECTOR ) EQVIRVR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVIRVR:= gleich;
  END; 
END;




GLOBAL OPERATOR <> ( VAR B : IVECTOR; VAR A : RVECTOR ) NEVIRVR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVIRVR:= ungleich;
  END;  
END;




{---------------------------------------------------------------------------}
{    3.4  Vergleiche von Argumenten IVECTOR mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR V44                                                                 }
{---------------------------------------------------------------------------}
 



GLOBAL OPERATOR =  ( VAR A,B : IVECTOR ) EQVIRVIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au ) DO
      IF A[i] = B[i+d] THEN      i:= SUCC(i)
                       ELSE gleich:= FALSE;
    EQVIRVIR:= gleich
  END
END;


 

GLOBAL OPERATOR <> ( VAR A,B : IVECTOR ) NEVIRVIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich  OR ( i > au );
    NEVIRVIR:= ungleich;
  END
END;



 
GLOBAL OPERATOR <= ( VAR A,B : IVECTOR ) LEVIRVIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] <= B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE;
    LEVIRVIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A,B : IVECTOR ) LTVIRVIR : BOOLEAN;

BEGIN
  LTVIRVIR:= ( A <= B ) AND ( A <> B )
END; 




GLOBAL OPERATOR >= ( VAR A,B : IVECTOR ) GEVIRVIR : BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au ) DO
      IF A[i] >= B[i+d] THEN         i:= SUCC(i)
                        ELSE obermenge:= FALSE;
    GEVIRVIR:= obermenge
  END
END;



 
GLOBAL OPERATOR > ( VAR A,B : IVECTOR ) GTVIRVIR : BOOLEAN;

BEGIN
  GTVIRVIR:= ( A >= B ) AND ( A <> B )
END;




GLOBAL OPERATOR >< ( VAR A,B : IVECTOR ) DISJVIRVIR : BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
          i := al;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt  OR ( i > au );
    DISJVIRVIR:= disjunkt
  END
END;




{---------------------------------------------------------------------------}
{    3.5  Vergleiche von Argumenten RMATRIX mit RMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR V55                                                                 }
{---------------------------------------------------------------------------}




{         ... sind bereits im Modul MV_ARI definiert.                       }




{---------------------------------------------------------------------------}
{    3.6  Vergleiche von Argumenten RMATRIX mit IMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR V56                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A : RMATRIX; VAR B : IMATRIX ) INMRMIR : BOOLEAN;

VAR drin        : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
      i := al1;
    drin:= TRUE;
    WHILE  drin  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN     i:= SUCC(i)
                        ELSE  drin:= FALSE;
    INMRMIR:= drin
  END
END;




GLOBAL OPERATOR = ( VAR A : RMATRIX; VAR B : IMATRIX) EQMRMIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMRMIR:= gleich
  END;
END;




GLOBAL OPERATOR <> ( VAR A : RMATRIX; VAR B: IMATRIX) NEMRMIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMRMIR:= ungleich
  END;
END;




{---------------------------------------------------------------------------}
{    3.7  Vergleiche von Argumenten IMATRIX mit RMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR V65                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR = ( VAR A : IMATRIX; VAR B : RMATRIX ) EQMIRMR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMIRMR:= gleich
  END;
END;




GLOBAL OPERATOR <> ( VAR A : IMATRIX; VAR B : RMATRIX ) NEMIRMR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMIRMR:= ungleich
  END;
END;




{---------------------------------------------------------------------------}
{    3.8  Vergleiche von Argumenten IMATRIX mit IMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR V66                                                                 }
{---------------------------------------------------------------------------}


 
 
GLOBAL OPERATOR =  ( VAR A,B : IMATRIX ) EQMIRMIR : BOOLEAN;

VAR gleich      : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
        i := al1;
    gleich:= TRUE;
    WHILE  gleich  AND ( i <= au1 ) DO
      IF A[i] = B[i+d] THEN       i:= SUCC(i)
                       ELSE  gleich:= FALSE;
    EQMIRMIR:= gleich
  END;
END;
 


 
GLOBAL OPERATOR <> ( VAR A,B : IMATRIX ) NEMIRMIR : BOOLEAN;

VAR ungleich    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    ungleich:= FALSE;
    REPEAT
      IF A[i] <> B[i+d] THEN ungleich:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  ungleich OR ( i > au1 );
    NEMIRMIR:= ungleich
  END
END;
 



GLOBAL OPERATOR <= ( VAR A,B : IMATRIX ) LEMIRMIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] <= B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE;
    LEMIRMIR:= teilmenge
  END
END;




GLOBAL OPERATOR < ( VAR A,B : IMATRIX ) LTMIRMIR : BOOLEAN;

BEGIN
  LTMIRMIR:= ( A <= B ) AND ( A <> B )
END;




GLOBAL OPERATOR >= ( VAR A,B : IMATRIX ) GEMIRMIR : BOOLEAN;

VAR obermenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    obermenge:= TRUE;
    WHILE  obermenge  AND ( i <= au1 ) DO
      IF A[i] >= B[i+d] THEN          i:= SUCC(i)
                        ELSE  obermenge:= FALSE;
    GEMIRMIR:= obermenge
  END
END;




GLOBAL OPERATOR > ( VAR A,B : IMATRIX ) GTMIRMIR : BOOLEAN;

BEGIN
  GTMIRMIR:= ( A >= B ) AND ( A <> B )
END;




GLOBAL OPERATOR >< ( VAR A,B : IMATRIX ) DISJMIRMIR : BOOLEAN;

VAR disjunkt    : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);   

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i:= al1;
    disjunkt:= FALSE;
    REPEAT
      IF A[i] >< B[i+d] THEN disjunkt:= TRUE
                        ELSE        i:= SUCC(i);
    UNTIL  disjunkt OR ( i > au1 );
    DISJMIRMIR:= disjunkt
  END
END;




{---------------------------------------------------------------------------}
{ 4. Arithmetische Operatoren                                               }
{---------------------------------------------------------------------------}
{    4.1  Monadische Operatoren                                             }
{---------------------------------------------------------------------------}
{         4.1.1 Monadische Operatoren fuer Vektoren                         }
{---------------------------------------------------------------------------}
{SEKTOR A04                                                                 }
{---------------------------------------------------------------------------}



 
GLOBAL OPERATOR + ( VAR A : IVECTOR ) PLUSVIR : IVECTOR [LB(A)..UB(A)];

BEGIN
  PLUSVIR:= A
END;




GLOBAL OPERATOR - ( VAR A : IVECTOR ) MINUSVIR : IVECTOR [LB(A)..UB(A)];

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MINUSVIR[i]:= -A[i]
END;




{---------------------------------------------------------------------------}
{         4.1.2 Monadische Operatoren fuer Matrizen                         }
{---------------------------------------------------------------------------}
{SEKTOR A06                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IMATRIX ) PLUSMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                         LB(A,2)..UB(A,2)];
BEGIN
  PLUSMIR:= A
END;




GLOBAL OPERATOR - ( VAR A : IMATRIX ) MINUSMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                          LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MINUSMIR[z,s]:= -A[z,s]
END;




{---------------------------------------------------------------------------}
{    4.2  Operatoren fuer Argumente REAL mit IVECTOR                        }
{---------------------------------------------------------------------------}
{SEKTOR A14                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( A : REAL; VAR B : IVECTOR )
                                       MULRVIR : IVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULRVIR[i]:= A * B[i]
END;




{---------------------------------------------------------------------------}
{    4.3  Operatoren fuer Argumente REAL mit IMATRIX                        }
{---------------------------------------------------------------------------}
{SEKTOR A16                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( A : REAL; VAR B : IMATRIX )
                                       MULRMIR : IMATRIX [LB(B,1)..UB(B,1),
                                                          LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULRMIR[z,s]:= A * B[z,s]
END;



{---------------------------------------------------------------------------}
{    4.4  Operatoren fuer Argumente INTERVAL mit RVECTOR                    }
{---------------------------------------------------------------------------}
{SEKTOR A23                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : RVECTOR ) 
                                               MULIRVR : IVECTOR[LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULIRVR[i]:= A * B[i]
END;


   

{---------------------------------------------------------------------------}
{    4.5  Operatoren fuer Argumente INTERVAL mit IVECTOR                    }
{---------------------------------------------------------------------------}
{SEKTOR A24                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : IVECTOR )
                                             MULIRVIR : IVECTOR [LB(B)..UB(B)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(B) TO UB(B) DO  MULIRVIR[i]:= A * B[i]
END;
 
 


{---------------------------------------------------------------------------}
{    4.6  Operatoren fuer Argumente INTERVAL mit RMATRIX                    }
{---------------------------------------------------------------------------}
{SEKTOR A25                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : RMATRIX ) 
                                          MULIRMR : IMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULIRMR[z,s]:= A * B[z,s]
END; 




{---------------------------------------------------------------------------}
{    4.7  Operatoren fuer Argumente INTERVAL mit IMATRIX                    }
{---------------------------------------------------------------------------}
{SEKTOR A26                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : INTERVAL; VAR B : IMATRIX )
                                         MULIRMIR : IMATRIX [LB(B,1)..UB(B,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(B,1) TO UB(B,1) DO
  FOR s:= LB(B,2) TO UB(B,2) DO  MULIRMIR[z,s]:= A * B[z,s]
END;




{---------------------------------------------------------------------------}
{    4.8  Operatoren fuer Argumente RVECTOR mit INTERVAL                    }
{---------------------------------------------------------------------------}
{SEKTOR A32                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RVECTOR; VAR B : INTERVAL ) 
                                               MULVRIR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVRIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : RVECTOR; VAR B : INTERVAL ) 
                                               DIVVRIR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVRIR[i]:= A[i] / B
END;



 
{---------------------------------------------------------------------------}
{    4.9  Operatoren fuer Argumente RVECTOR mit RVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A33                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A,B : RVECTOR ) COHUVRVR : IVECTOR[LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVRVR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.10 Operatoren fuer Argumente RVECTOR mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A34                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : RVECTOR; VAR B : IVECTOR ) 
                                             ADDVRVIR : IVECTOR[LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVRVIR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - ( VAR A : RVECTOR; VAR B : IVECTOR )
                                             SUBVRVIR : IVECTOR[LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVRVIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A : RVECTOR; VAR B : IVECTOR ) MULVRVIR : INTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVRVIR:= ##( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;




GLOBAL OPERATOR +* ( VAR A : RVECTOR; VAR B : IVECTOR ) 
                                            COHUVRVIR : IVECTOR[LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVRVIR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.11 Operatoren fuer Argumente IVECTOR mit REAL                        }
{---------------------------------------------------------------------------}
{SEKTOR A41                                                                 }
{---------------------------------------------------------------------------}

 

GLOBAL OPERATOR * ( VAR A : IVECTOR; B : REAL ) 
                                        MULVIRR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;
 
BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVIRR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : IVECTOR; B : REAL ) 
                                        DIVVIRR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVIRR[i]:= A[i] / B
END;




{---------------------------------------------------------------------------}
{    4.12 Operatoren fuer Argumente IVECTOR mit INTERVAL                    }
{---------------------------------------------------------------------------}
{SEKTOR A42                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IVECTOR; VAR B : INTERVAL ) 
                                             MULVIRIR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  MULVIRIR[i]:= A[i] * B
END;




GLOBAL OPERATOR / ( VAR A : IVECTOR; VAR B : INTERVAL )
                                             DIVVIRIR : IVECTOR[LB(A)..UB(A)];
VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO  DIVVIRIR[i]:= A[i] / B 
END;




{---------------------------------------------------------------------------}
{    4.13 Operatoren fuer Argumente IVECTOR mit RVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A43                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IVECTOR; VAR B : RVECTOR ) 
                                             ADDVIRVR : IVECTOR[LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVIRVR[i]:= A[i] + B[i+d]
END;




GLOBAL OPERATOR - (  VAR A : IVECTOR; VAR B : RVECTOR ) 
                                             SUBVIRVR : IVECTOR[LB(A)..UB(A)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVIRVR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * (  VAR A : IVECTOR; VAR B : RVECTOR ) MULVIRVR : INTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVIRVR:= ##( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;




GLOBAL OPERATOR +* (  VAR A : IVECTOR; VAR B : RVECTOR ) 
                                             COHUVIRVR : IVECTOR[LB(A)..UB(B)];
VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVIRVR[i]:= A[i] +* B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.14 Operatoren fuer Argumente IVECTOR mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A44                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A, B : IVECTOR ) ADDVIRVIR : IVECTOR [LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  ADDVIRVIR[i]:= A[i] + B[i+d]
END;


   

GLOBAL OPERATOR - ( VAR A, B : IVECTOR ) SUBVIRVIR : IVECTOR [LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  SUBVIRVIR[i]:= A[i] - B[i+d]
END;




GLOBAL OPERATOR * ( VAR A, B : IVECTOR ) MULVIRVIR : INTERVAL;

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
    MULVIRVIR:= ##( FOR i:= al TO au SUM ( A[i] * B[i+d] ) )
END;




GLOBAL OPERATOR +* ( VAR A,B : IVECTOR ) COHUVIRVIR : IVECTOR [LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  COHUVIRVIR[i]:= A[i] +* B[i+d]
END;




GLOBAL OPERATOR ** ( VAR A,B : IVECTOR ) INTSCTVIRVIR : IVECTOR [LB(A)..UB(A)];

VAR i, al,bl,au, d : INTEGER;

BEGIN
  al:= LB(A);  au:= UB(A);
  bl:= LB(B);

   d:= bl - al;

  IF au - al  <> UB(B) - bl THEN  m_MATH_ERROR ( 201 )
  ELSE
     FOR i:= al TO au DO  INTSCTVIRVIR[i]:= A[i] ** B[i+d]
END;




{---------------------------------------------------------------------------}
{    4.15 Operatoren fuer Argumente RMATRIX mit INTERVAL                    }
{---------------------------------------------------------------------------}
{SEKTOR A52                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RMATRIX; VAR B : INTERVAL ) 
                                          MULMRIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMRIR[z,s]:= A[z,s] * B
END; 




GLOBAL OPERATOR / ( VAR A : RMATRIX; VAR B : INTERVAL ) 
                                          DIVMRIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMRIR[z,s]:= A[z,s] / B
END; 




{---------------------------------------------------------------------------}
{    4.16 Operatoren fuer Argumente RMATRIX mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A54                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : RMATRIX;  VAR B : IVECTOR )
                                         MULMRVIR : IVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMRVIR[i]:=  A[i] * B
END;




{---------------------------------------------------------------------------}
{    4.17 Operatoren fuer Argumente RMATRIX mit RMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR A55                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR +* ( VAR A,B : RMATRIX ) COHUMRMR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMRMR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;
 



{---------------------------------------------------------------------------}
{    4.18 Operatoren fuer Argumente RMATRIX mit IMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR A56                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : RMATRIX; VAR B : IMATRIX )
                                         ADDMRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMRMIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : RMATRIX; VAR B : IMATRIX )
                                         SUBMRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMRMIR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A : RMATRIX; VAR B : IMATRIX ) 
                                         MULMRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMRMIR[z,s]:= A[z] * IVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A : RMATRIX; VAR B : IMATRIX )
                                        COHUMRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMRMIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;



{---------------------------------------------------------------------------}
{    4.19 Operatoren fuer Argumente IMATRIX mit REAL                        }
{---------------------------------------------------------------------------}
{SEKTOR A61                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX; B : REAL ) 
                                       MULMIRR : IMATRIX [LB(A,1)..UB(A,1),
                                                          LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMIRR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : IMATRIX; B : REAL ) 
                                          DIVMIRR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMIRR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{    4.20 Operatoren fuer Argumente IMATRIX mit INTERVAL                    }
{---------------------------------------------------------------------------}
{SEKTOR A62                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : INTERVAL )
                                         MULMIRIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  MULMIRIR[z,s]:= A[z,s] * B
END;




GLOBAL OPERATOR / ( VAR A : IMATRIX; B : INTERVAL )
                                         DIVMIRIR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  DIVMIRIR[z,s]:= A[z,s] / B
END;




{---------------------------------------------------------------------------}
{    4.21 Operatoren fuer Argumente IMATRIX mit RVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A63                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX;  VAR B : RVECTOR )
                                         MULMIRVR : IVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMIRVR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{    4.22 Operatoren fuer Argumente IMATRIX mit IVECTOR                     }
{---------------------------------------------------------------------------}
{SEKTOR A64                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR * ( VAR A : IMATRIX;  VAR B : IVECTOR )
                                        MULMIRVIR : IVECTOR [LB(A,1)..UB(A,1)];
VAR i : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B) - LB(B) ) THEN  m_MATH_ERROR ( 203 )
  ELSE
    FOR i:= LB(A,1) TO UB(A,1) DO  MULMIRVIR[i]:= A[i] * B
END;




{---------------------------------------------------------------------------}
{     4.23 Operatoren fuer Argumente IMATRIX mit RMATRIX                    }
{---------------------------------------------------------------------------}
{SEKTOR A65                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A : IMATRIX; VAR B : RMATRIX )
                                         ADDMIRMR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMIRMR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A : IMATRIX; VAR B : RMATRIX )
                                         SUBMIRMR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMIRMR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A : IMATRIX; VAR B : RMATRIX ) 
                                         MULMIRMR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMIRMR[z,s]:= A[z] * RVECTOR(B[*,s])
END; 




GLOBAL OPERATOR +* ( VAR A : IMATRIX; VAR B : RMATRIX )
                                        COHUMIRMR : IMATRIX [LB(A,1)..UB(A,1),
                                                             LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMIRMR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{    4.24 Operatoren fuer Argumente IMATRIX mit IMATRIX                     }
{---------------------------------------------------------------------------}
{SEKTOR A66                                                                 }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR + ( VAR A, B : IMATRIX )
                               ADDMIRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  ADDMIRMIR[z,s]:= A[z,s] + B[z+d1,s+d2]
END;




GLOBAL OPERATOR - ( VAR A, B : IMATRIX )
                               SUBMIRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  SUBMIRMIR[z,s]:= A[z,s] - B[z+d1,s+d2]
END;




GLOBAL OPERATOR * ( VAR A, B : IMATRIX )
                               MULMIRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                    LB(B,2)..UB(B,2)];
VAR z,s : INTEGER;

BEGIN
  IF ( UB(A,2) - LB(A,2) <> UB(B,1) - LB(B,1) )  THEN  m_MATH_ERROR ( 204 )
  ELSE
    FOR z:= LB(A,1) TO UB(A,1) DO
    FOR s:= LB(B,2) TO UB(B,2) DO  MULMIRMIR[z,s]:= A[z] * IVECTOR(B[*,s])
END;




GLOBAL OPERATOR +* ( VAR A, B : IMATRIX )
                               COHUMIRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                     LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  COHUMIRMIR[z,s]:= A[z,s] +* B[z+d1,s+d2]
END;
      



GLOBAL OPERATOR ** ( VAR A,B : IMATRIX )
                            INTSCTMIRMIR : IMATRIX [LB(A,1)..UB(A,1),
                                                    LB(A,2)..UB(A,2)];
VAR z,s, d1,d2,
    al1,al2,au1,au2, bl1,bl2,bu1,bu2 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  al2:= LB(A,2);  au2:= UB(A,2);
  bl1:= LB(B,1);  bu1:= UB(B,1);
  bl2:= LB(B,2);  bu2:= UB(B,2);

   d1:= bl1 - al1;
   d2:= bl2 - al2;

  IF ( au1-al1 <> bu1-bl1 ) OR ( au2-al2 <> bu2-bl2 ) THEN m_MATH_ERROR( 202 )
  ELSE
    FOR z:= al1 TO au1 DO
    FOR s:= al2 TO au2 DO  INTSCTMIRMIR[z,s]:= A[z,s] ** B[z+d1,s+d2]
END;




{---------------------------------------------------------------------------}
{ 5. Ein -  / Ausgabe                                                       }
{---------------------------------------------------------------------------}



 
GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : IVECTOR );

VAR i : INTEGER;

BEGIN
  FOR i:= LB(A) TO UB(A) DO READ( F, A[i] )
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; VAR A : IVECTOR );

VAR i : INTEGER;

BEGIN
  WRITELN( F );
  FOR i:= LB(A) TO UB(A) DO  WRITELN( F, A[i] );
END;




GLOBAL PROCEDURE READ  ( VAR F : TEXT; VAR A : IMATRIX );

VAR z,s : INTEGER;

BEGIN
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  READ( F, A[z,s] );
END;




GLOBAL PROCEDURE WRITE ( VAR F : TEXT; VAR A : IMATRIX );

VAR z,s : INTEGER;

BEGIN
  WRITELN( F );
  FOR z:= LB(A,1) TO UB(A,1) DO
  BEGIN
    FOR s:= LB(A,2) TO UB(A,2) DO  WRITELN( F, A[z,s] );
    WRITELN( F )
  END
END;




{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{    3.4 Vergleiche IVECTOR mit IVECTOR                                     }
{---------------------------------------------------------------------------}




GLOBAL OPERATOR IN ( VAR A,B : IVECTOR ) INVIRVIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al,au,bl,bu : INTEGER;

BEGIN
  al:= LB(A); au:= UB(A);
  bl:= LB(B); bu:= UB(B);

  d:= bl - al;

  IF ( au - al ) <> ( bu  - bl ) THEN  m_MATH_ERROR ( 201 )  ELSE
  BEGIN
        i := al;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au ) DO
      IF A[i] IN B[i+d] THEN         i:= SUCC(i)
                        ELSE teilmenge:= FALSE;
    INVIRVIR:= teilmenge
  END
END;




{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{    3.8 Vergleiche IMATRIX mit IMATRIX                                     }
{---------------------------------------------------------------------------}



GLOBAL OPERATOR IN ( VAR A,B : IMATRIX ) INMIRMIR : BOOLEAN;

VAR teilmenge   : BOOLEAN;
    i,d,
    al1,au1,bl1 : INTEGER;

BEGIN
  al1:= LB(A,1);  au1:= UB(A,1);
  bl1:= LB(B,1);

  d:= bl1 - al1;

  IF (    au1  -  al1    <> UB(B,1) -  bl1    ) OR
     ( UB(A,2) - LB(A,2) <> UB(B,2) - LB(B,2) )   THEN m_MATH_ERROR( 202 )
  ELSE
  BEGIN
           i := al1;
    teilmenge:= TRUE;
    WHILE  teilmenge  AND ( i <= au1 ) DO
      IF A[i] IN B[i+d] THEN          i:= SUCC(i)
                        ELSE  teilmenge:= FALSE;
    INMIRMIR:= teilmenge
  END
END;



{---------------------------------------------------------------------------}
{
{  Zusatz zu :
{
{---------------------------------------------------------------------------}
{ 2. Spezielle Funktionen                                                   }
{---------------------------------------------------------------------------}
{    2.7 Epsilon - Aufblaehung                                              }
{---------------------------------------------------------------------------}


GLOBAL FUNCTION BLOW( VAR A : IVECTOR; EPS : REAL ) : IVECTOR[LB(A)..UB(A)];
 
VAR i : INTEGER;
    E : REAL;
    B : INTERVAL;

BEGIN
  E:= 1.0 + EPS;
  FOR i:= LB(A) TO UB(A) DO  BEGIN
                                B:= E*A[i] - EPS*A[i];
                                BLOW[i].INF:= PRED( B.INF );
                                BLOW[i].SUP:= SUCC( B.SUP );
                             END;
END;
 


 
GLOBAL FUNCTION BLOW ( VAR A : IMATRIX; EPS : REAL ) : IMATRIX[LB(A,1)..UB(A,1),
                                                               LB(A,2)..UB(A,2)];
VAR z,s : INTEGER;           
    E   : REAL;
    B   : INTERVAL;

BEGIN
  E:= 1.0 + EPS;
  FOR z:= LB(A,1) TO UB(A,1) DO
  FOR s:= LB(A,2) TO UB(A,2) DO  BEGIN
                                    B:= E*A[z,s] - EPS*A[z,s];
                                    BLOW[z,s].INF:= PRED( B.INF );
                                    BLOW[z,s].SUP:= SUCC( B.SUP );
                                 END;
END;  





END.  { of module MVI_ARI }

