MODULE awarout;

USE GLOBAL eingabe;

GLOBAL VAR
   INFILE,OUTFILE    : TEXT;
   i,N,FERTIG        : INTEGER;
   NULL_EINS,
   INULL, EINS, ZWEI  : INTERVAL;   
   FNULL,FEINS,FZWEI : FORMEL;
   C                 : CHAR;
   JA_SET            : SET OF CHAR;
   PROTOKOLL         : BOOLEAN;
   

GLOBAL PROCEDURE ASK( VAR F : TEXT );
BEGIN
   WRITE(F,' -> ?',CHR(8));
END;

GLOBAL FUNCTION JA( VAR F : TEXT; S : STRING ) : BOOLEAN;
VAR C : CHAR;
BEGIN
   WRITE(F,S,' ?',CHR(8));
   IF NOT LASTITEM(INFILE) THEN READ(INFILE,C);
   JA:= C IN JA_SET;
END;
 
GLOBAL FUNCTION EVAL( VAR F : FORMEL; VAR U : IVECTOR; VAR T : INTERVAL )
                    : INTERVAL;
FUNCTION VAL( VAR F : FORMEL ) : INTERVAL;
BEGIN
   WITH  F^  DO
   CASE  OPER  OF
      PLUS    : IF LI^.OPER = KONST THEN  VAL:= LI^.WERT + VAL(RE)  ELSE
                IF RE^.OPER = KONST THEN  VAL:= VAL(LI)  + RE^.WERT ELSE
                                          VAL:= VAL(LI)  + VAL(RE);
      MINUS   : IF LI^.OPER = KONST THEN  VAL:= LI^.WERT - VAL(RE)  ELSE
                IF RE^.OPER = KONST THEN  VAL:= VAL(LI)  - RE^.WERT ELSE
                                          VAL:= VAL(LI)  - VAL(RE);
      MAL     : IF LI^.OPER = KONST THEN  VAL:= LI^.WERT * VAL(RE)  ELSE
                IF RE^.OPER = KONST THEN  VAL:= VAL(LI)  * RE^.WERT ELSE
                                          VAL:= VAL(LI)  * VAL(RE);
      DURCH   : IF LI^.OPER = KONST THEN  VAL:= LI^.WERT / VAL(RE)  ELSE
                IF RE^.OPER = KONST THEN  VAL:= VAL(LI)  / RE^.WERT ELSE
                                          VAL:= VAL(LI)  / VAL(RE);
      UMINUS  : VAL:= - VAL(R);
      QUAD    : VAL:= SQR   ( VAL(R)  );
      WURZ    : VAL:= SQRT  ( VAL(R)  );
      HOCH    : VAL:= EXP   ( EXPO*LN(VAL(R)) );
      EFKT    : VAL:= EXP   ( VAL(R)  );
      LOGA    : VAL:= LN    ( VAL(R)  );
      SINUS   : VAL:= SIN   ( VAL(LI) );
      COSIN   : VAL:= COS   ( VAL(LI) );
      TANG    : VAL:= TAN   ( VAL(LI) );
      COTANG  : VAL:= COT   ( VAL(LI) );
      SINUSH  : VAL:= SINH  ( VAL(LI) );
      COSINH  : VAL:= COSH  ( VAL(LI) );
      TANGH   : VAL:= TANH  ( VAL(LI) );
      COTANGH : VAL:= COTH  ( VAL(LI) );
      ARCSI   : VAL:= ARCSIN( VAL(LI) );
      ARCCO   : VAL:= ARCCOS( VAL(LI) );
      ARCTG   : VAL:= ARCTAN( VAL(LI) );
      ARCCTG  : VAL:= ARCCOT( VAL(LI) );
      ARSIH   : VAL:= ARSINH( VAL(LI) );
      ARCOH   : VAL:= ARCOSH( VAL(LI) );
      ARTGH   : VAL:= ARTANH( VAL(LI) );
      ARCTGH  : VAL:= ARCOTH( VAL(LI) );
      KONST   : VAL:= WERT;
      AVARIABLE: VAL:= U[I];
      UVARIABLE: VAL:= T;
   END;
END  {  VAL  };

BEGIN
   EVAL:= VAL( F );
END  {  EVAL  };

GLOBAL FUNCTION EVAL( VAR F : FVECTOR; VAR U : IVECTOR; VAR T : INTERVAL )
                    : IVECTOR[LBOUND(F)..UBOUND(F)];
VAR I : INTEGER;
BEGIN
   FOR I:= LBOUND(F) TO UBOUND(F) DO  EVAL[I]:= EVAL( F[I], U, T );
END;

GLOBAL PROCEDURE QR( VAR A : RMATRIX );
{ Berechnet QR-Zerlegung der Matrix A.            }
{ Ausgabe im Parameter A : orthogonale Matrix Q   }
VAR I,J,K,NL,NU : INTEGER;
    Q           : RMATRIX[LBOUND(A)..UBOUND(A),LBOUND(A)..UBOUND(A)];
    B,C         : RVECTOR[LBOUND(A)..UBOUND(A)];
    S           : REAL;
BEGIN
   NL:= LBOUND(A);
   NU:= UBOUND(A);
   FOR I:= NL TO NU DO
   FOR K:= NL TO NU DO
                    IF I=K THEN Q[I,K]:= 1.0 ELSE Q[I,K]:= 0.0;
   FOR K:= NL TO NU-1 DO  
   BEGIN 
      S:= 0.0;
      FOR I:= K TO NU DO
      BEGIN
         B[I]:= A[I,K];
         IF S<ABS(B[I]) THEN S:= ABS(B[I]);
      END;
      IF S > 0.0 THEN
      BEGIN
         S:= SQRT( B*B );
         IF A[K,K]>=0 THEN S:= -S;
         B[K]:= A[K,K] - S;
         S:= 1/(S*B[K]);
         C:= S*B;
         FOR J:= K+1 TO NU DO
         BEGIN
            S:= C*RVECTOR(A[*,J]);
            FOR I:= K TO NU DO A[I,J]:= A[I,J] + B[I]*S;
         END;
         FOR I:= NL TO NU DO
         BEGIN
            S:= RVECTOR(Q[I])*C;
            FOR J:= K TO NU DO Q[I,J]:= Q[I,J] + S*B[J];
         END;
      END;
      B[K]:= 0.0;  C[K]:= 0.0;
   END;
   A:= Q;
END; {=== QR ===}
 
GLOBAL PROCEDURE QR_ZERL( VAR PHI : RMATRIX; VAR REST : IVECTOR );
{ Veranlasst QR-Zerlegung von PHI nach Sortieren der Spalten von PHI } 
{ Globalen Variable : N                                              }
VAR I,J,K     : INTEGER;
    HV,LAENGE : RVECTOR[1..N];
    HR        : REAL; 
BEGIN
   FOR I:= 1 TO N DO 
      LAENGE[I]:= SQR(DIAM(REST[I]))*( RVECTOR(PHI[*,I])*RVECTOR(PHI[*,I]) );
   FOR J:=  1  TO N-1 DO
   FOR K:= J+1 TO  N  DO
   BEGIN
      IF LAENGE[J]<LAENGE[K] THEN
      BEGIN
         HR:= LAENGE[K];          LAENGE[K]:= LAENGE[J]; LAENGE[J]:= HR;
         HV:= RVECTOR(PHI[*,K]);  PHI[*,K] := PHI[*,J];  PHI[*,J] := HV;
      END;
   END;
   QR(PHI);     { PHI wird mit Q aus der QR-Zerlegung von PHI ueberschrieben }
END  {  QR_ZERL  };

GLOBAL PROCEDURE EINLESEN1 ( VAR               F    : TEXT;
                                               N    : INTEGER;
                             VAR ABSCHNITT,AUS      : INTEGER;
                             VAR TT,TSTART,TEND,H   : REAL;
                             VAR P,E_ART,AUSGABE    : INTEGER;
                             VAR REST0,REST1        : IVECTOR;
                             VAR RESTMAT            : RMATRIX  );
{ Liest diejenigen Daten ein, die benoetigt werden, wenn ein neuer Integra-
{ tionsabschnitt begonnen werden soll : AUS, T, H, P, E_ART, AUSGABE         }
{ Diese Daten koennen also in einzelnen Teilintervallen der Integration      }
{ variiert werden.                                                           }
{ Wird E_ART ( Einschliessungs-Art ) waehrend der Integration veraendert,    }
{ so muessen die Intervalle REST0, REST1 und die Matrix RESTMAT evtl. neu    }
{ angepasst werden.                                                          }
{ Globale Variablen : AUS, T, H, P, E_ART, AUSGABE, t,                       }
{                     REST0, REST1, RESTMAT                                  }
VAR EA  : INTEGER;
    tstart_int,tend_int,h_int   : interval;
BEGIN
   WRITELN(F);
   WRITE(F,EINL1_1); ASK(F);

   READ(INFILE,  AUS  );
   WRITELN(F); WRITELN(F,EINL1_2,  AUS  );
   if aus<=0 then writeln(f,einl1_2a);

   READ(INFILE, tstart_int );
   if diam(tstart_int) > 0 then writeln(f,einl1_3a);
   TSTART:= mid(tstart_int);
   WRITELN(F,EINL1_3,TSTART );

   READ(INFILE, tend_int );
   if diam(tend_int) > 0 then writeln(f,einl1_4a);
   TEND:= mid(tend_int);
   WRITELN(F,EINL1_4, TEND  );

   READ(INFILE, H );
   WRITELN(F,EINL1_5, H );

   READ(INFILE,   P   );
   if p<2 then 
   begin
      writeln(f,einl1_6a); 
      p:= 2;
   end;
                                     WRITELN(F,EINL1_6,   P   );
   TT:= TSTART;
   WRITELN(F);
   WRITELN(F,EINL1_7 );
   WRITELN(F,EINL1_8 );
   WRITELN(F,EINL1_9 );
   WRITELN(F,EINL1_10);
   WRITE  (F,EINL1_11); ASK(F);
   READ(INFILE,EA); 
   IF (ABSCHNITT>1) AND (E_ART<>EA) THEN
               IF E_ART=0 THEN BEGIN
                                  REST1:= REST0;  RESTMAT:= ID(N);
                               END ELSE
               IF E_ART<3 THEN REST0:= RESTMAT*REST1;
   IF (EA>=0) AND (EA<=4) THEN E_ART:= EA ELSE E_ART:= 4;
   CASE E_ART OF
      0: WRITELN(F,EINL1_12);
      1: WRITELN(F,EINL1_13);
      2: WRITELN(F,EINL1_14);
      3: WRITELN(F,EINL1_15);
      4: WRITELN(F,EINL1_16);
   END;
   WRITELN(F);
   WRITELN(F,EINL1_17);
   WRITELN(F,EINL1_18);
   WRITELN(F,EINL1_19);
   WRITELN(F,EINL1_20);
   WRITELN(F,EINL1_21);
   WRITELN(F,EINL1_22);
   WRITELN(F,EINL1_23);
   WRITE  (F,EINL1_24,CHR(8));
   READ(INFILE,AUSGABE);
   if (ausgabe>0) and (ausgabe<7) then writeln(f,einl1_24a);
   IF AUSGABE<>7 THEN AUSGABE:= 0;
 { IF (AUSGABE<0) OR (AUSGABE>7) THEN AUSGABE:= 0;  }
   WRITELN(F,' ( ',AUSGABE:1,' )'); WRITELN(F);

   IF PROTOKOLL THEN
   BEGIN
      WRITELN(OUTFILE);
      WRITELN(OUTFILE,EINL1_2,  AUS   );
      if aus<=0 then writeln(outfile,einl1_2a);
      WRITELN(OUTFILE,EINL1_3, TSTART );
      if diam(tstart_int) > 0 then writeln(outfile,einl1_3a);
      WRITELN(OUTFILE,EINL1_4, TEND   );
      if diam(tend_int) > 0 then writeln(outfile,einl1_4a);
      WRITELN(OUTFILE,EINL1_5,   H    );
      WRITELN(OUTFILE,EINL1_6,   P    );
      WRITELN(OUTFILE);
      WRITE  (OUTFILE,EINL1_25);
      CASE E_ART OF
         0: WRITELN(OUTFILE,EINL1_12);
         1: WRITELN(OUTFILE,EINL1_13);
         2: WRITELN(OUTFILE,EINL1_14);
         3: WRITELN(OUTFILE,EINL1_15);
         4: WRITELN(OUTFILE,EINL1_16);
      END;
      WRITELN(OUTFILE);
      WRITE  (OUTFILE,EINL1_26);
      CASE AUSGABE OF
      0: WRITELN(OUTFILE,EINL1_27);
      1: WRITELN(OUTFILE,EINL1_28);
      2: WRITELN(OUTFILE,EINL1_29);
      3: WRITELN(OUTFILE,EINL1_30);
      4: WRITELN(OUTFILE,EINL1_31);
      5: WRITELN(OUTFILE,EINL1_32);
      6: WRITELN(OUTFILE,EINL1_33);
      7: WRITELN(OUTFILE,EINL1_34);
      END;
      WRITELN(OUTFILE);
   END;
END  {  EINLESEN1  };

GLOBAL PROCEDURE EINLESEN2( VAR F                       : TEXT;
                                N,AUSGABE               : INTEGER;
                            VAR UEBER                   : BOOLEAN;
                            VAR ANFANG,REST,REST0,REST1 : IVECTOR;
                            VAR RESTMAT,ABBMAT          : RMATRIX  );
{ Liest diejenigen Daten ein, die benoetigt werden, wenn fuer einen Integra- }
{ tionsabschnitt ein neuer Anfangsvektor vorgegeben werden soll : ANFANG und,}
{ wenn noetig, UEBER. Ausserdem werden verschiedene Initialisierungen vorge- }
{ nommen.                                                                    }
{ Globale Variablen : ANFANG, AUSGABE, UEBER, REST,                          }
{                     REST0, REST1, RESTMAT, ABBMAT                          }
VAR I : INTEGER;
    B : BOOLEAN;
    C : CHAR;
BEGIN
   B:= FALSE;
   WRITE(F,EINL2_1); ASK(F);
   FOR I:= 1 TO N DO
   BEGIN
      READ( INFILE, ANFANG[I] );
      WRITELN(F,'U0[',I:2,'] =  [ ', ANFANG[I].INF:22:0:-1,', ',ANFANG[I].SUP:22:0:+1,']');
      B:= B OR (ANFANG[I].SUP>ANFANG[I].INF);
   END;
   WRITELN(F);
   IF B AND (AUSGABE=0) THEN
   BEGIN
      UEBER:= JA(F,EINL2_2);
      IF UEBER THEN WRITELN(F,YES) ELSE WRITELN(F,NO);
   END ELSE UEBER:= FALSE;
   REST0 := VNULL(N);   REST1  := REST0;    REST:= REST0;
   ABBMAT:= ID(N);      RESTMAT:= ABBMAT;
END  {  EINLESEN2  };

GLOBAL PROCEDURE SCHREIBE( VAR F          : TEXT;
                               N,AUSGABE  : INTEGER;
                               UEBER      : BOOLEAN;
                               TT         : REAL;
                               U1,L1,REST : IVECTOR;
                               F_START    : H_VARIABLEN );
{ Fuehrt die Ausgabe der Ergebnisse auf OUTPUT durch. In Abhaengigkeit vom   }
{ Wert von AUSGABE wird jeweils folgendes ausgedruckt:                       }
{ Zunaechst der aktuelle Gitterpunkt t, dann                                 }
{ AUSGABE = 0 : zeilenweise fuer jede Komponente des Loesungsvektors         }
{               das berechnete Einschliessungsintervall, dessen Durchmesser  }
{               ( auf 4 Stellen nach oben gerundet ) und eine Einschliessung }
{               aller Steigungen auf dem zurueckliegenden Integrations-Inter-}
{               vall ( falls UEBER=FALSE ) bzw. eine obere Schranke fuer die }
{               Ueberschaetzung der Loesungsmenge (falls UEBER=TRUE, dann war}
{               ein echtes Anfangsintervall vorgelegen )                     }
{           7 : Die Werte der Variablen, die in der Ausgabeliste aufgezaehlt }
{               wurden, werden jeweils berechnet und ausgegeben.             }
{                                                                            }
{ In den Faellen 1..6 liegen alle Daten im Array U_K vor, im Fall 0 steht die}
{ Loesungseinschliessung in U1,das "Steigungsintervall" ist L1 und die Ueber-}
{ schaetzung steht in REST. Im Fall 7 werden die Werte jeweils neu berechnet.}
{ Globale Variablen : t, N, AUSGABE, U, P, U_K, UEBER, U1, L1, REST          }
VAR I,J : INTEGER;
    A   : INTERVAL;
    VARI: H_VARIABLEN;
BEGIN
   WRITELN(F);
   WRITELN(F, 't = ', TT );
   IF NOT UEBER THEN
      IF AUSGABE=7 THEN
      BEGIN
         VARI:= F_START;
         WHILE VARI<>NIL DO
         BEGIN
            WRITE(F, VARI^.NAME:SMAX );
            A:= EVAL( VARI^.AUSDRUCK, U1, INTVAL(TT) );
            WRITELN(F, ': [', A.INF:22:0:-1, ',', A.SUP:22:0:+1, '] ', DIAM(A):10:0:+1 );
            VARI:= VARI^.NEXT;
         END;
      END
      ELSE
      FOR I:= 1 TO N DO
      begin
         WRITE  (F, '[', U1[I].INF:22:0:-1, ',', U1[I].SUP:22:0:+1, '] ',DIAM(U1[I]):10:0:1 );
         if 0.0 in u1[i] then write(F,'   ---    ')
                         else write(F,' ',diam(u1[i])/>inf(abs(u1[i])):9:0:1 );
         writeln(F);
    {    writeln(F, '  [', L1[I].INF:10:0:-1, ',', L1[I].SUP:10:0:+1, ']' );   }
      end
   ELSE
      FOR I:= 1 TO N DO
      WRITELN(F, '[', U1[I].INF:22:0:-1, ',', U1[I].SUP:22:0:+1, '] ',DIAM(U1[I]):10:0:1,
                 '  ',DIAM(REST[I]):0:0:+1 );
      { !!!  Bei Ausgabe der Ueberschaetzung ( = DIAM(REST[I] ) noch nicht
             alle Rundungsfehler beruecksichtigt !!!  }
END  {  SCHREIBE  };
 

BEGIN
   I:= 0;
END.
