/* Written by B. Hoeffgen, Bergische Universitaet Wuppertal, 2004 */
/* eMail: hoeffgen@uni-wuppertal.de                               */
/*                                                                */
/* (c) 2000-2004 Wissenschaftliches Rechnen/Softwaretechnologie   */
/*               Universitaet Wuppertal, Germany                  */
/*								  */
/* subst.c: Anpassung der Benutzerpfade und Generierung der       */
/*          Dateien p88.env und defs.h                            */
/*                                                                */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LEN 256

int main(int argc, char *argv[]){
	FILE *in, *out;
	char line[LEN];
	int c;

	if(argc<2 || strcmp(argv[0],"-h")==0 || strcmp(argv[0],"--help")==0 || strcmp(argv[0],"")==0){
		printf("\nUsage: %s <FILE1> <FILE2> <PATH>\n\n",argv[0]);
		return 1;
	}
	
	/* p88.env erzeugen */
	in = fopen(argv[1],"rb");
	if(!in){
		printf("File %s couldn't be opened!\n",argv[1]);
		return 1;
	}
	
	out = fopen("p88.env","wb");
	if(!out){
		printf("File %s couldn't be opened!\n",argv[1]);
		return 1;
	}
	
	fprintf(out,"\n");
	do{
		c = fscanf(in,"%s",line);
		if(strchr(line,'p')!=NULL && strchr(line,'/')!=NULL){
			sprintf(line,"p%s%c",argv[3],'/');
		}
		fprintf(out,"%s\n",line);
	}while(c!=EOF);
	
	fclose(in);
	fclose(out);
	/* Ende p88.env erzeugen */
	
	/* defs.h erzeugen */
	in = fopen(argv[2],"r");
	if(!in){
		printf("File %s couldn't be opened!\n",argv[1]);
		return 1;
	}
	
	out = fopen("../src/defs.h","w");
	if(!out){
		printf("File %s couldn't be opened!\n",argv[1]);
		return 1;
	}
	
	while(fgets(line,LEN,in)!=NULL){
		if(strstr(line,"/usr/local/p-xsc/sys/")!=NULL){
			sprintf(line,"#define\t\tSYSdir\t\t\"%s/sys/\"\n",argv[3]);
		}
		if(strstr(line,"/usr/local/p-xsc/user/")!=NULL){
			sprintf(line,"#define\t\tUSRdir\t\t\"%s/user/\"\n",argv[3]);
		}
		fprintf(out,"%s",line);
	}
	
	fclose(in);
	fclose(out);
	/* Ende defs.h erzeugen */
	
	
	return 0;
}
